import _ from 'lodash';

type RuleResult = number | false | undefined;

export const getMinimumRuleOutput = async <T>(
  rules: ((input: T) => RuleResult | Promise<RuleResult>)[],
  input: T,
) => {
  const results = await Promise.all(rules.map((rule) => rule(input)));
  return Math.min(..._.compact(results));
};
